/********************************************************************
 FileName:      Grafic LCD            AQM1248A.c
 Dependencies:  See INCLUDES section
 Processor:     PIC18F14K50
 Compiler:      Microchip XC8

  Copyright (c) 2014 iwamoto All Rights Reserved
********************************************************************
 File Description:

 Change History:
  Rev   Date         Description
  1.0   20014/1/2   Initial release
********************************************************************/
#include <xc.h>
#include "AQM1248A.h"

//-------- G-LCD --------------------------------------
void LCD_int (void){
    LCD_cmd (0xAE);        // Display = OFF
    LCD_cmd (0xA0);        // ADC = normal
    LCD_cmd (0xC8);        // Common output = revers
    LCD_cmd (0xA3);        // bias = 1/7
                           //--M[^Ԃɂnm
    LCD_cmd (0x2C);        // power control 1
    __delay_ms(2);         // 2mSx
    LCD_cmd (0x2E);        // power control 2
    __delay_ms(2);         // 2mSx
    LCD_cmd (0x2F);        // power control 3
                           //--RgXgݒ
    LCD_cmd (0x23);        // Vo voltage resistor ratio set
    LCD_cmd (0x81);        // Electronic volume mode set
    LCD_cmd (0x1C);        // Electronic volume value set
                           //--\ݒ
    LCD_cmd (0xA4);        // display all point normaliS_Ȃj
    LCD_cmd (0x40);        // display start line = 0
    LCD_cmd (0xA6);        // Display normal(]Ȃj
    LCD_cmd (0xAF);        // Display = ON
    LCD_clr ();            // f[^RAMS
}

//-------- G-LCDɃR}hꕶM -----------------------
void LCD_cmd (char cmd){
    SPI_CS = 0;                  // `bvZNgL
    SPI_RS = 0;                  // R}hf[^w
    SSPBUF = cmd;                // f[^̑MJn
    while(!SSPSTATbits.BF);      // M҂
    cmd = SSPBUF;                // BFZbg邽ߋǂ
    SPI_CS = 1;                  // `bvZNg
}

//-------- G-LCD RAMɈoCgM ------------------------
void LCD_ram (char dat){
    SPI_CS = 0;                  // `bvZNgL
    SPI_RS = 1;                  // \f[^w
    SSPBUF = dat;                // f[^̑MJn
    while(!SSPSTATbits.BF);      // M҂
    dat = SSPBUF;                // BFZbg邽ߋǂ
    SPI_CS = 1;                  // `bvZNg
}

//-------- G-LCDɈꕶ\ --------------------------------
void LCD_dat (char dat){
    char i,chptn;
    dat -= 0x20;                 //zAhXvZ
    for(i=0; i<5; i++) {         //Rf[^Ɏ擾
        chptn = chrom[dat][i];
        if(chptn == 0xFF)break;  //Ȃ甲
        LCD_ram(chptn);          //Rf[^]
    }
    LCD_ram(0);                  //Ԋu󂯂
}

//-------- G-LCD̃f[^S ----------------------------
void LCD_clr (void){
    unsigned char i,j;
    for(j=0; j<8; j++) {         //y[WXV
        LCD_posyx (j,0);         //y[Ww
        for(i=0; i<128; i++) {   //y[WRAMf[^
            LCD_ram (0);         //  NA
        }
    }
}
//-------- J[\ʒuw --------------------------------------
void LCD_posyx(char ypos, unsigned char xpos){
    LCD_cmd(0xB0 | ypos);        //y[Ww
    LCD_cmd(0x10 | (xpos >> 4)); //y[WRAMAhX
    LCD_cmd(xpos & 0xF);         //  w
}

//-------- o --------------------------------------------
void LCD_str(char *str){
    while(*str)                  //I[(00)܂Ōp
        LCD_dat(*str++);         //o͂|C^{P
}

//-------- Rom o -----------------------------------------
void LCD_ROMstr(const char *str){
    while(*str)                  //I[(00)܂Ōp
        LCD_dat(*str++);         //o͂|C^{P
}

//-------- \  ---------------------------------------------
// R[hA\ʒuiypos, xpos)w肷B
// \A̕\Jnʒu xpos Ԃ
//----------------------------------------------------------------
unsigned char LCD_chr1x(char dat, char ypos, unsigned char xpos){
    char i,chptn;
    dat -= 0x20;                 //zAhXvZ
    LCD_posyx( ypos, xpos);      //㔼̕\ʒuw
    for(i=0; i<5; i++) {         //Rf[^Ɏ擾
        chptn = chrom[dat][i];
        if(chptn == 0xFF)break;  //Ȃ甲
        LCD_ram(chptn);          //Rf[^]
    }
    LCD_ram(0);                  //Ԋu󂯂
    return i + 1 + xpos;         //̕\Jnʒu xpos Ԃ
}

//-------- \ ----------------------------------------
// AhXA\ʒuiypos, xpos)w肷B
// \A̕\Jnʒu xpos Ԃ
//------------------------------------------------------------
unsigned char LCD_str1x(char *str, char ypos, unsigned char xpos){
    while(*str)                                //I[(00)܂Ōp
        xpos = LCD_chr1x(*str++, ypos, xpos);  //o͂
    return xpos;                               //\ʒuԂ
}

//-------- \ ROMGA--------------------------------------
// AhXA\ʒuiypos, xpos)w肷B
// \A̕\Jnʒu xpos Ԃ
//-------------------------------------------------------------------
unsigned char LCD_ROMstr1x(const char *str, char ypos, unsigned char xpos){
    while(*str)                                //I[(00)܂Ōp
        xpos = LCD_chr1x(*str++, ypos, xpos);  //o͂|C^{P
    return xpos;                               //\ʒuԂ
}

//-------- g啶\ --------------------------------------
// R[hA\ʒuiypos, xpos)w肷B
// x2 TCYŕ\A̕\Jnʒu xpos Ԃ
//------------------------------------------------------------
unsigned char LCD_chr2x(char dat, char ypos, unsigned char xpos){
    unsigned char wch,fnt,i;
    dat -= 0x20;                 //zAhXvZ
    LCD_posyx( ypos, xpos);      //㔼̕\ʒuw
    for(i=0;i<5;i++){            //
        wch = chrom[dat][i];     //LN^f[^LSB 4bit
        if(wch == 0xFF)break;    //g債LCD RAMɓ]
        fnt = 0;
        if(wch & 0b00000001)fnt  = 0b00000011;
        if(wch & 0b00000010)fnt |= 0b00001100;
        if(wch & 0b00000100)fnt |= 0b00110000;
        if(wch & 0b00001000)fnt |= 0b11000000;
        LCD_ram(fnt);  LCD_ram(fnt);
    }
     LCD_ram(0);  LCD_ram(0);

    LCD_posyx( ypos + 1, xpos);  //̕\ʒuw
    for(i=0;i<5;i++){            //
        wch = chrom[dat][i];     //LN^f[^MSB 4bit
        if(wch == 0xFF)break;    //g債LCD RAMɓ]
        fnt = 0;
        if(wch & 0b00010000)fnt  = 0b00000011;
        if(wch & 0b00100000)fnt |= 0b00001100;
        if(wch & 0b01000000)fnt |= 0b00110000;
        if(wch & 0b10000000)fnt |= 0b11000000;
        LCD_ram(fnt);  LCD_ram(fnt);
    }
     LCD_ram(0);  LCD_ram(0);
    return (i + 1) * 2 + xpos;   //̕\Jnʒu xpos Ԃ
}

//-------- g啶\ --------------------------------------
// AhXA\ʒuiypos, xpos)w肷B
// x2 TCYŕ\A̕\Jnʒu xpos Ԃ
//--------------------------------------------------------------
unsigned char LCD_str2x(char *str, char ypos, unsigned char xpos){
    while(*str)                                //I[(00)܂Ōp
        xpos = LCD_chr2x(*str++, ypos, xpos);  //o͂
    return xpos;                               //\ʒuԂ
}

//-------- g啶\ ROMGA--------------------------------------
// AhXA\ʒuiypos, xpos)w肷B
// x2 TCYŕ\A̕\Jnʒu xpos Ԃ
//-----------------------------------------------------------------------
unsigned char LCD_ROMstr2x(const char *str, char ypos, unsigned char xpos){
    while(*str)                                //I[(00)܂Ōp
        xpos = LCD_chr2x(*str++, ypos, xpos);  //o͂|C^{P
    return xpos;                               //\ʒuԂ
}

//-------- 3{g啶\ Tri Font -----------------------------
// R[hA\ʒuiypos, xpos)w肷B
// x3 TCYŕ\A̕\Jnʒu xpos Ԃ
//---------------------------------------------------------------
unsigned char LCD_chr3x(char dat, char ypos, unsigned char xpos){
    unsigned char wch,fnt,i;
    dat -= 0x20;                 //zAhXvZ
    LCD_posyx( ypos, xpos);      //㔼̕\ʒuw
    for(i=0;i<5;i++){            //
        wch = chrom[dat][i];     //LN^f[^LSB 4bit
        if(wch == 0xFF)break;    //g債LCD RAMɓ]
        fnt = 0;
        if(wch & 0b00000001)fnt  = 0b00000111;
        if(wch & 0b00000010)fnt |= 0b00111000;
        if(wch & 0b00000100)fnt |= 0b11000000;
        LCD_ram(fnt);  LCD_ram(fnt);  LCD_ram(fnt);
    }

    LCD_posyx( ypos + 1, xpos);  //̕\ʒuw
    for(i=0;i<5;i++){            //
        wch = chrom[dat][i];     //LN^f[^MSB 4bit
        if(wch == 0xFF)break;    //g債LCD RAMɓ]
        fnt = 0;
        if(wch & 0b00000100)fnt |= 0b00000001;
        if(wch & 0b00001000)fnt |= 0b00001110;
        if(wch & 0b00010000)fnt |= 0b01110000;
        if(wch & 0b00100000)fnt |= 0b10000000;
        LCD_ram(fnt);  LCD_ram(fnt);  LCD_ram(fnt);
    }

    LCD_posyx( ypos + 2, xpos);  //̕\ʒuw
    for(i=0;i<5;i++){            //
        wch = chrom[dat][i];     //LN^f[^MSB 4bit
        if(wch == 0xFF)break;    //g債LCD RAMɓ]
        fnt = 0;
        if(wch & 0b00100000)fnt |= 0b00000011;
        if(wch & 0b01000000)fnt |= 0b00011100;
        if(wch & 0b10000000)fnt |= 0b11100000;
        LCD_ram(fnt);  LCD_ram(fnt);  LCD_ram(fnt);
    }
     LCD_ram(0);  LCD_ram(0);  LCD_ram(0);
    return (i + 1) * 3 + xpos;   //̕\Jnʒu xpos Ԃ
}

//-------- 3{g啶\ --------------------------------------
// AhXA\ʒuiypos, xpos)w肷B
// x3 TCYŕ\A̕\Jnʒu xpos Ԃ
//-----------------------------------------------------------------
unsigned char LCD_str3x(char *str, char ypos, unsigned char xpos){
    while(*str)                                //I[(00)܂Ōp
        xpos = LCD_chr3x(*str++, ypos, xpos);  //o͂
    return xpos;                               //\ʒuԂ
}

//-------- 3{g啶\ ROMGA--------------------------------------
// AhXA\ʒuiypos, xpos)w肷B
// x3 TCYŕ\A̕\Jnʒu xpos Ԃ
//------------------------------------------------------------
unsigned char LCD_ROMstr3x(const char *str, char ypos, unsigned char xpos){
    while(*str)                                //I[(00)܂Ōp
        xpos = LCD_chr3x(*str++, ypos, xpos);  //o͂|C^{P
    return xpos;                               //\ʒuԂ
}

