//  File name: SPI Mode II Grafic LCD 
//             
//     RC4  SPI_RS     0:R}h  1:f[^
//     RC5  SPI_CS     0:L      1:
//     RC7  SPISDO
//     RB6  SPISCK     idle:Hi   SCK̗Ńf[^ύX
//  Language: MPLABX XC8
//  Target: PIC18F14K50
//  Copyright (c) 2014 iwamoto All Rights Reserved

#include <xc.h>
#include "AQM1248A.h"
#define  _XTAL_FREQ 16000000      // delay_ms(x) ̂߂̒`

//-------------- RtBO[V --------------------------------
#pragma config MCLRE  = OFF
#pragma config PWRTEN = OFF, BOREN  = OFF, BORV   = 30
#pragma config WDTEN  = OFF, WDTPS  = 32768
#pragma config STVREN = ON
#pragma config FOSC   = IRC  //  NbN
#pragma config PLLEN  = ON,  CPUDIV = NOCLKDIV, USBDIV = OFF
#pragma config FCMEN  = OFF, IESO   = OFF, HFOFST = OFF
#pragma config LVP    = OFF, XINST  = OFF, BBSIZ  = OFF
#pragma config CP0    = OFF, CP1 = OFF, CPB = OFF, CPD = OFF
#pragma config WRT0   = OFF, WRT1 = OFF
#pragma config WRTB   = OFF, WRTC = OFF, WRTD = OFF
#pragma config EBTR0  = OFF, EBTR1 = OFF, EBTRB = OFF

void main(void){
    unsigned char i,ypos,xpos;
    OSCCON = 0b01110010;            // NbN16Mhz
    mInitLCD_IO ();                 // LCDpI/O ݒ
    mInitSPI();                     // SPI Mode II ݒ
    ANSEL  = 0b00000000;            // SăfW^I/O
    ANSELH = 0b00000000;
    LCD_int ();                     // Grafic LCD ݒ

    ypos = 0; xpos = 10;                    // \ʒu
    xpos = LCD_ROMstr3x("ABC",ypos,xpos);   // R{\
    ypos = 1; 
    xpos = LCD_ROMstr2x("ABC",ypos,xpos);   // Q{\
    ypos = 2;
    xpos = LCD_ROMstr1x("ABC",ypos,xpos);   // ʏ핶\

    LCD_posyx (4,20);                       // \ʒu
    LCD_dat('S');                           // ʏ핶\
    LCD_ROMstr("PI LCD AQM1248A");          // ʏ핶\

    LCD_posyx (5,0);                        // ig\ʒu
    for(i=0; i<128 ; i+=2) {                // Rf[^Ɏ擾
        LCD_ram(0b11101000);                // igl
        LCD_ram(0b11010000);
    }
    while(1);
}
